//GPX Garmin - pro nov Garmin GPS

//..............................................................................
//Authors:
//Medwyn

//..............................................................................
{Changelog:
=== 0.1 (3. 8. 2009) ===
   * vodn verze
   
=== 0.2 (10. 6. 2010) ===
   * Pidna promnn EXPORT_WAYPOINTS. Pomoci promnn se nastavuje, zda skript bude exportovat dodaten waypointy.
   * Pidna promnn EXPORT_STARTING_AS_REFERENCE. V ppad pesunu kee na finln waypoint vyexportuje pvodn startovn souadnice jako referenn bod. (Dve implicitn chovn pi pesunu souadnic, dnes voliteln.)
   * Pidna monost exportovat libovoln tagy v rmci EXPORT_INFO pomoc EXPORT_TAGS.

=== 0.3 (1. 11. 2010) ===
   * Skript byl kompletn peloen do etiny
   * Pidna monost exportovat kee se zadanmi finlovmi souadnicemi do speciln kategorie. V GPS jsou pot zobrazeny s ikonkou zaven truhliky (na map i v seznamu ke). Nevhodou tohoto een je fakt, e takto upraven kee nelze pot filtrovat pomoc integrovanch filtr v GPS (protoe GPS kategorii nezn).    
   * Popis waypoint by ml bt nyn zobrazen i v navigaci Dakota (popis je vkldn jak do tagu <desc>, tak do tagu <cmt>)
   * Waypointy maj definovny ikonky dle typu, aby je bylo mono jednodue rozliit v seznamu a v map
   * Pidna monost definovat si klov slova, na jejich vskyt bude pot prohledvn listing. Kad nalezen slovo bude barvn zvraznno a na tuto skutenost je upozornno na zatku listingu. Praktick napklad pro zvraznn textu "bonus".       
   * Pidna monost odstraovat pebyten seznam waypoint, kter Groundspeak vkld na konec listingu v PQ
   * Pidna monost zobrazit si seznam ke, kter maj pli dlouh listing a pravdpodobn dojde v navigaci k jeho zkrcen.
   * Export nyn exportuje pouze MAX_WPTS poet waypoint. V ppad, e je tento poet pekroen, ji nejsou do souboru dal waypointy zapisovny.   

=== 0.3.0.1 (2. 11. 2010) ===
   * Doasn verze opravujc chybu s generovnm nevalidnch GPX vstup (chyba vznikala pi exportu waypoint na kech, kter obsahovaly vylutnou finln lokaci).

=== 0.4 (5. 1. 2010) ===
   * Pro formtovn vstupu je nyn pouita knihovna [[VarSubst]]. Kad uivatel makra si tak me konfigurovat formt vstupu pesn dle svch preferenc
   * Pro uren cest k ablonm je vyuito funkc knihovny [[RelToAbsPath]].
   * Pidna monost nechat si v listingu vyznaovat msta, na kterch je obrzek (pokud obsahuje alternativn text, je zobrazen)   
   * Mnostv zmn v konfiguraci vstupu. 
   * Dlen listingu - lep vyuvn vlastnost Garminu. Nyn dokeme zobrazit a 16kB dlouh listing (dve pouze 8kB). Hodn tak klesne poet ke, jejich listing je useknut ped koncem
   * Vylepena funkce na odstraovn zbytench HTML tag v listingu
   * Monost voliteln mnit kategorie exportovanch waypoint (Garmin jim piad ikonky (aspo barevn) podobn tm z GC.com)
   * Vchoz hodnoty nastaven makra jsou nyn pro Oregon 550 (aktualizoval jsem HW ;-) ) 
   * Lokalizace je nyn k dispozici v etin a anglitin. Added english language version.   
}
  
uses VarSubstUnit, RelToAbsPathUnit;
{$INCLUDE gpxgarmin.config.pas}
{$INCLUDE gpxgarmin.varsubst.lib.pas}

const
  DIVIDE_LISTING_MAX_TAGLENGTH = '200';
  DIVIDE_LISTING_CHARCOUNT = '8100';
  MAX_LISTING_CHARCOUNT = '16200';
  TRUNCATED_EXPORTS_GGT_DIR = 'truncated exports';
  
var
  ExportedGC,ExportedWpt : Integer;
  truncatedListings: TStringList;
  errors : String;
  TemplatePointName, TemplatePointDescription, TemplateWaypointName, TemplateWaypointDescription : string;

function FILE_NOT_FOUND: String;
begin
    Result := _('File not found');
end;

function ERROR: String;
begin
    Result := _('Error!');
end;

function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  result := _('GPX Garmin - for newest Garmin GPS');
end;

procedure TemplateFileToVariableIfExists(srcfile : String; var destvar : String);
begin
    if FileExists(srcfile)
      then destvar := AnsiToUtf(FileToString(srcfile))
      else errors := errors + FILE_NOT_FOUND + ': ' + srcfile + CRLF;
end;

procedure ExportInit;
begin
  //INICIALIZACE
  errors := '';
  truncatedListings := TStringList.Create; 
  
  //KONTROLA NASTAVENI
  if not DirectoryExists(GetTemplateFolder) then errors := errors + FILE_NOT_FOUND + ': '+ GetTemplateFolder + CRLF;
  
  //NACTENI SABLON
  TemplateFileToVariableIfExists(GetTemplatePointName,TemplatePointName);
  TemplateFileToVariableIfExists(GetTemplatePointDescription,TemplatePointDescription);
  TemplateFileToVariableIfExists(GetTemplateWaypointName,TemplateWaypointName);
  TemplateFileToVariableIfExists(GetTemplateWaypointDescription,TemplateWaypointDescription);
  
  if errors <> '' then 
  begin
      ShowMessage(ERROR + CRLF + errors);
      GeoAbort;
  end;
  
  //PRIPRAVA POUZITYCH KNIHOVEN
  //Zaregistrujeme u knihovny VarSubst sve prekladove funkce
  VarSubst_GpxGarminRegister;
end;

function ExportHeader: string;
begin
  {Inicializace}
  ExportInit;

  {Hlavicka}
  Result := '<?xml version="1.0" encoding="utf-8"?>' + CRLF;
  Result := Result + '<gpx xmlns:xsd="http://www.w3.org/2001/XMLSchema"'
    + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0"'
    + ' creator="Groundspeak Pocket Query"'
    + ' xsi:schemaLocation="http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd'
    + ' http://www.groundspeak.com/cache/1/0 http://www.groundspeak.com/cache/1/0/cache.xsd"'
    + ' xmlns="http://www.topografix.com/GPX/1/0">' + CRLF;
  Result := Result + ' <desc>Geocache file</desc>' + CRLF;
  Result := Result + ' <author>' + Geoget_Version + '</author>' + CRLF;
  Result := Result + ' <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', now) + '</time>' + CRLF;
  Result := Result + ' <keywords>cache, geocache, groundspeak</keywords>' + CRLF + CRLF;
end;

function ExportFooter: string;
begin
  result := '</gpx>' + CRLF;
end;

function ExportAfter(value: string): string;
var
   s,truncfile: String;
   Size: Integer;
begin
  Result := '';
  
  {Zpracujeme seznam oriznutych listingu}
  if (CHECK_LISTING_LENGTH = '1') then
  begin
    truncfile := ReplaceString(GEOGET_SCRIPTFULLNAME,GEOGET_SCRIPTNAME,'') + TRUNCATED_EXPORTS_GGT_DIR + '\';
    ForceDirectories(truncfile);
    truncfile := truncfile + RegexExtract('[^\\]*$',value) + ' - ' + FormatDateTime('yyyymmddhhnnss',now) + '.ggt';
    if (truncatedListings.count > 0) then truncatedListings.SaveToFile(truncfile);  
  end;

  If (SHOW_EXPORT_WARNINGS = '1') Then
  begin
    If (ExportedGC > StrToInt(MAX_CACHES)) Then 
    begin
      s := s + _('Warning! The maximal number of points (%MAX_CACHES%) was exceeded (%EXPORTED_CACHES%).' + CRLF + 'The GPS receiver might not be able to show all the exported points.') + CRLF + CRLF;
      s := ReplaceString(s,'%MAX_CACHES%',MAX_CACHES);
      s := ReplaceString(s,'%EXPORTED_CACHES%',IntToStr(ExportedGC));
    end;
    If (ExportedWpt > StrToInt(MAX_WPTS)) Then 
    begin
      s := s + _('Warning! The maximal number of waypoints (%MAX_WPTS%) was exceeded (%EXPORTED_WPTS%).' + CRLF + 'Only first %MAX_WPTS% waypoints (in the displayed order) were exported.') + CRLF + CRLF;
      s := ReplaceString(s,'%MAX_WPTS%',MAX_WPTS);
      s := ReplaceString(s,'%EXPORTED_WPTS%',IntToStr(ExportedWpt));
    end;
    Size := GetFileSize(value);
    If (Size > StrToInt(MAX_SIZE)) Then 
    begin
      s := s + _('Warning! The maximal size of the result file (%MAX_SIZE% kB) was exceeded (%EXPORTED_SIZE% kB).' + CRLF + 'The GPS receiver might not be able to load the file. Try to adjust the export settings to lower the filesize.') + CRLF + CRLF;
      s := ReplaceString(s,'%MAX_SIZE%',IntToStr(StrToInt(MAX_SIZE)*1024));
      s := ReplaceString(s,'%EXPORTED_SIZE%',IntToStr(Size*1024));
    end;
    If ((truncatedListings.count > 0) and (CHECK_LISTING_LENGTH = '1')) Then 
    begin
      s := s + _('Warning! Listing length of %TRUNCATED_COUNT% points exceeds the maximal allowed length. The GPS receiver might not be able to show them correctly.') + CRLF + CRLF;
      s := ReplaceString(s,'%TRUNCATED_COUNT%',IntToStr(truncatedListings.count));
    end;
    If (s <> '') Then 
    begin
      If ((truncatedListings.count > 0) and (CHECK_LISTING_LENGTH = '1')) then
      begin
         s := s + _('Would you like to view the list of problematic points with listings of excessive length?');
         
         if (MessBox(s,ERROR,4) = 6) then
         begin
             //Zobrazit seznam
             GeoListClear;
             GeoListFileAdd(truncfile);
         end;
      end
      else Showmessage(s);
    end;
  end;

  {Uvolnime pamet}
  truncatedListings.Free;
end;

function FormatLog(LogID,LogType,FinderID,Finder,Text :String; Date :TDateTime) : String;
var
  s : String;
begin
  Result := '    <groundspeak:log id="' + LogID + '">' + CRLF
          + '     <groundspeak:date>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', Date) + '</groundspeak:date>' + CRLF
          + '     <groundspeak:type>' + LogType + '</groundspeak:type>' + CRLF;
  s := '';
  if FinderID <> '' then
    s := ' id="' + FinderID + '"'; 
  Result := Result 
          + '     <groundspeak:finder' + s + '>' + cdata(Finder) + '</groundspeak:finder>' + CRLF
          + '     <groundspeak:text encoded="False">' + cdata(CleanupHtml(Text)) + '</groundspeak:text>' + CRLF
          + '    </groundspeak:log>' + CRLF;
end;

{Metoda vraci GPX kod s logy na predanem TGeo}
function ExportLogs(geo : TGeo): String;
var n : Integer;
begin
    Result := '';
    for n := 0 to Minimum(geo.Logs.count,StrToInt(EXPORT_LOGS_MAXCOUNT))-1 do
    begin
       Result := Result + FormatLog(geo.Logs[n].LogID,geo.Logs[n].LogType,geo.Logs[n].FinderID,geo.Logs[n].Finder,geo.Logs[n].Text,geo.Logs[n].Date);
    end;
end;

{Metoda vraci jmeno symbolu, ktery ma byt pouzit pro waypoint}
function WaypointSymbol(WptType : String): String;
begin
  Result := WptType;
  if (CHANGE_WAYPOINT_SYMBOLS = '1') then
  begin
    case WptType of
      'Final Location':           begin Result := 'Flag, Red'; end; 
      'Parking Area':             begin Result := 'Parking Area'; end;
      'Question to Answer':       begin Result := 'Flag, Green'; end;
      'Reference Point':          begin Result := 'Navaid, Blue'; end;
      'Stages of a Multicache':   begin Result := 'Flag, Blue'; end;
      'Trailhead' :               begin Result := 'Navaid, Green'; end;
    end;
  end;  
end;

function GetNonUTF8MultibyteCharPosition(source : String; startPosition : Integer) : Integer;
var ch : Char;
begin
    for Result := startPosition downto 1 do
    begin
       ch := source[Result];
       if ((ch > #126) or (ch < #32)) 
          then continue
          else break; 
    end;
end;

function CheckLeftRemainderForAngleOpen(source : String; maxlength : Integer) : Integer;
var n,minpos,len : Integer;
    ch : Char;
begin
   Result := -1;
   len := Length(source);
   minpos := len - maxlength;
   if minpos < -1 then minpos := 1;
   
   for n := len downto minpos do //kontrolujeme vsechny znaky od zacatku az po minimalni pozici
   begin
      ch := source[n];
      case ch of
      '<': begin Result := n; Exit; end; //narazili jsme na otevreni tagu. Bacha, asi rezeme uprostred tagu. Vratime podezrely index.
      '>': begin Exit; End; //narazili jsme na zavreni tagu. Tak je to asi v poradku a vratime -1 jako OK
      end;
   end; 
end;
 
function CheckRightRemainderForAngleClose(source : String; maxlength : Integer) : Integer;
var n,maxpos,len : Integer;
    ch : Char;
begin
   Result := -1;
   len := Length(source);
   maxpos := Minimum(len,maxlength);
   
   for n := 1 to maxpos do //kontrolujeme vsechny znaky od zacatku az po maximalni pozici
   begin
      ch := source[n];
      case ch of
      '>': begin Result :=n; Exit; end; //narazili jsme na zavreni tagu. Bacha, asi rezeme uprostred tagu. Vratime podezrely index.
      '<': begin Exit; end; //narazili jsme na otevreni tagu. Tak je to asi v poradku a vratime -1 jako OK
      end;
   end;   
end;

function GetNonHTMLTagPosition(source : String; startPosition: Integer) : Integer;
var leftpart,rightpart : String;
    vicinity,lindex,rindex: Integer;
begin
    Result := startPosition;
    vicinity := StrToInt(DIVIDE_LISTING_MAX_TAGLENGTH);
    
    leftpart := copy(source,1,startPosition);
    rightpart := copy(source,startPosition+1,Length(source)-startPosition); 
    
    lindex := CheckLeftRemainderForAngleOpen(leftpart,vicinity);
    rindex := CheckRightRemainderForAngleClose(rightpart,vicinity);
    
    if ((lindex <> -1) and (rindex <> -1)) then
    begin
        Result := lindex-1;
    end;
end;

function DivideListing(source : String; var remainder : String; maxlength : Integer; GCID : String) : String;
var divideIndex : Integer;
begin
    Result := '';
    if (Length(source) < maxlength) then //neni treba nic delit
      begin
        Result := source;
        remainder := '';
      end
    else  //listing rozdelime
      begin
        divideIndex := maxlength;
        
        //najdeme pozici, ktera neni uprostred vicebytoveho UTF-8 znaku
        divideIndex := GetNonUTF8MultibyteCharPosition(source,divideIndex);
        
        //najdeme pozici, ktera neni uprostred html tagu (<htTADYml>)
        divideindex := GetNonHTMLTagPosition(source,divideIndex);

        Result := copy(source,1,divideIndex);
        remainder := copy(source,divideIndex+1,Length(source)-divideIndex);
      end;
end;

function BoolToStr(bool : boolean) : String;
begin
    if bool then Result := 'True' else Result := 'False';
end;

procedure LoadStartingCoordinates(geo : TGeo; wpt : TWpt);
begin
   wpt.SetDefault;
   wpt.ParentID := geo.ID;
   wpt.ParentKey;
   wpt.Lat := geo.Lat;
   wpt.Lon := geo.Lon;
   wpt.PrefixID := START_COORDINATES_PREFIX;
   wpt.Description := AnsiToUtf(_('Original start coordinates'));
   wpt.Name := AnsiToUtf(_('Start coordinates'));
   wpt.WptType := 'Reference Point';
end;

function FormatPoint(wWptLat,wWptLon : String; wWptTime :TDateTime; wWptName,wWptCmt,wWptDesc,wWptUrl,wWptUrlName,wWptSym,wWptType : String; isGeocache : boolean; wGsCacheID : String; wGsAvailable,wGsArchived : boolean; wGsName,wGsPlacedBy,wGsOwnerID,wGsOwner,wGsType,wGsContainer,wGsDifficulty,wGsTerrain,wGsCountry,wGsState,wGsShortDesc,wGsLongDesc,wGsHint,wGsLogs : String) : String;
begin
  Result := ' <wpt lat="' + wWptLat + '" lon="' + wWptLon + '">' + CRLF;
  if wWptTime    <> 0  then Result := Result + '  <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', wWptTime) + '</time>' + CRLF;
  if wWptName    <> '' then Result := Result + '  <name>' + cdata(wWptName) +'</name>' + CRLF;
  if wWptCmt     <> '' then Result := Result + '  <cmt>' + cdata(wWptCmt) +'</cmt>' + CRLF;
  if wWptDesc    <> '' then Result := Result + '  <desc>' + cdata(wWptDesc) +'</desc>' + CRLF;
  if wWptUrl     <> '' then Result := Result + '  <url>' + cdata(wWptUrl) +'</url>' + CRLF;
  if wWptUrlName <> '' then Result := Result + '  <urlname>' + cdata(wWptUrlName) + '</urlname>' + CRLF;
  if wWptSym     <> '' then Result := Result + '  <sym>' + wWptSym + '</sym>' + CRLF;
  if wWptType    <> '' then Result := Result + '  <type>' + wWptType + '</type>' + CRLF;
  if isGeocache then
  begin
      Result := Result
      + '  <groundspeak:cache id="'+ wGsCacheID+ '" available="' + BoolToStr(wGsAvailable) + '" archived="' + BoolToStr(wGsArchived) + '" xmlns:groundspeak="http://www.groundspeak.com/cache/1/0">' + CRLF
      + '   <groundspeak:name>' + cdata(wGsName) + '</groundspeak:name>' + CRLF
      + '   <groundspeak:placed_by>' + cdata(wGsPlacedBy) +'</groundspeak:placed_by>' + CRLF;
      if GC.OwnerID <> '' then Result := Result + '   <groundspeak:owner id="' + GC.OwnerID + '">' + cdata(GC.Author) +'</groundspeak:owner>' + CRLF;
      Result := Result 
      + '   <groundspeak:type>' + wGsType +'</groundspeak:type>' + CRLF
      + '   <groundspeak:container>' + wGsContainer +'</groundspeak:container>' + CRLF
      + '   <groundspeak:difficulty>' + wGsDifficulty +'</groundspeak:difficulty>' + CRLF
      + '   <groundspeak:terrain>' + wGsTerrain +'</groundspeak:terrain>' + CRLF
      + '   <groundspeak:country>' + wGsCountry +'</groundspeak:country>' + CRLF
      + '   <groundspeak:state>' + wGsState +'</groundspeak:state>' + CRLF
      + '   <groundspeak:short_description html="True">' + cdata(wGsShortDesc) +'</groundspeak:short_description>' + CRLF
      + '   <groundspeak:long_description html="True">' + cdata(wGsLongDesc) +'</groundspeak:long_description>' + CRLF
      + '   <groundspeak:encoded_hints>' + cdata(wGsHint) +'</groundspeak:encoded_hints>' + CRLF 
      + '   <groundspeak:logs>' + CRLF + wGsLogs 
      + '   </groundspeak:logs>' + CRLF +
      + '  </groundspeak:cache>' + CRLF;
  end;
  Result := Result + ' </wpt>' + CRLF + CRLF;
end;

function TemplateToOutput(template : String; geo : TGeo; wpt : TWpt; var output: string) : boolean;
begin
   Result := false;
   output := template;

   //nahradime promenne skutecnymi daty
   if (geo <> nil) then Result := VarSubstGeo(geo, output, false, output)  
   else if (wpt <> nil) then Result := VarSubstWpt(wpt, output, false, output);
   
   output := RegexReplace('(\r\n){2,}',output,CRLF,false); //smazat vicenasobne CRLF
end;

procedure ThrowTemplateRunningError (description: String);
var s :String;
begin
   s := _('Error running template: %DESCRIPTION%' + CRLF + 'The export will now exit.')
   s := ReplaceString(s,'%DESCRIPTION%',description);
   ShowMessage(s);
   GeoAbort;
end;

function ExportWaypoint(wpt : TWpt) : String;
var
  wWptLat,wWptLon,wWptName,wWptCmt,wWptDesc,wWptSym,wWptType : String;
  wWptTime : TDateTime;
begin
  Result := '';
  ExportedWpt := ExportedWpt + 1;
  if (ExportedWpt <= StrToInt(MAX_WPTS)) then
  begin
    {wWptLat} wWptLat := wpt.Lat;
    {wWptLon} wWptLon := wpt.Lon;
    {wWptTime} wWptTime := wpt.parentgeo.Hidden;
    {wWptName} 
    if (not TemplateToOutput(TemplateWaypointName, nil, wpt, wWptName)) 
      then ThrowTemplateRunningError(GetTemplateWaypointName + ' ' + wpt.id);
    {wWptCmt}
    if (not TemplateToOutput(TemplateWaypointDescription, nil, wpt, wWptCmt)) 
      then ThrowTemplateRunningError(GetTemplateWaypointDescription + ' ' + wpt.id);
    {wWptDesc} wWptDesc := wWptCmt;
    {wWptSym} wWptSym := WaypointSymbol(wpt.WptType);
    {wWptType} wWptType := 'Waypoint|' + wpt.WptType;

    Result := Result + FormatPoint(wWptLat,wWptLon,wWptTime,wWptName,wWptCmt,wWptDesc,'','',wWptSym,wWptType,false,'',false,false,'','','','','','','','','','','','','','');
  end;
end;

function ExportWaypoints(geo : TGeo) : String;
var
    myWpt : TWpt;
    n : Integer;
begin
   Result := '';
   If (EXPORT_WAYPOINTS = '1') then
   Begin 
    //Pokud ma keska upravene souradnice, nejprve pridame novy waypoint s odkazem na originalni vychozi souradnice
      If (geo.HaveFinal AND (EXPORT_FINAL_AS_STARTING = '1') AND (EXPORT_STARTING_AS_REFERENCE = '1') AND (EXPORT_WAYPOINTS = '1')) then
      begin
        myWpt := TWpt.Create;
        try
           LoadStartingCoordinates(geo, myWpt);
           Result := Result + ExportWaypoint(myWpt);
        finally
           myWpt.Free;
        end;
      end;
      
      for n := 0 to geo.Waypoints.Count - 1 do
        if (not geo.Waypoints[n].isEmptyCoord) and (geo.Waypoints[n].isListed) then
        begin
          //Pokud exportujeme kesku na upravene souradnice, nechceme na stejnem miste jeste final waypoint/y
          If Not ((geo.HaveFinal) AND (EXPORT_FINAL_AS_STARTING = '1') AND (geo.Waypoints[n].Lat = geo.CorrectedLat) AND (geo.Waypoints[n].Lon = geo.CorrectedLon) AND (geo.Waypoints[n].WptType = 'Final Location')) then
          begin   
            //Pokud exportujeme pouze final waypointy u nalezenych kesi
            if geo.isFound and (EXPORT_ONLY_FINAL_WAYPOINTS_WHEN_FOUND = '1') then
            begin
              if geo.Waypoints[n].WptType = 'Final Location' then  Result := Result + ExportWaypoint(geo.Waypoints[n]);
            end
            else
            begin
               Result := Result + ExportWaypoint(geo.Waypoints[n]);
            end;
          end;
        end;
   end;
end;

function ExportPoint: string;
var
  wWptLat,wWptLon,wWptName,wWptCmt,wWptDesc,wWptUrl,wWptUrlName,wWptSym,wWptType,wGsCacheID,wGsName,wGsPlacedBy,wGsOwnerID,wGsOwner,wGsType,wGsContainer,wGsDifficulty,wGsTerrain,wGsCountry,wGsState,wGsShortDesc,wGsLongDesc,wGsHint,wGsLogs : String;
  wGsAvailable,wGsArchived : boolean;
  wWptTime : TDateTime;
  
  listing: string;
begin
  Result := '';
  //Export GEOCACHE
   
  if (not GC.isEmptyCoord) and (GC.isListed) then
  begin
    ExportedGC := ExportedGC + 1;

    {wLat, wLon} if (GC.haveFinal AND (EXPORT_FINAL_AS_STARTING = '1')) then
    {wLat, wLon} begin wWptLat := GC.CorrectedLat; wWptLon := GC.CorrectedLon; end
    {wLat, wLon} else begin wWptLat := GC.Lat; wWptLon := GC.Lon; end;
    {wWptTime} wWptTime := GC.Hidden;
    {wWptName} wWptName := GC.ID;
    {wWptCmt}  wWptCmt := '';
    {wWptDesc} wWptDesc := GC.Name + ' by ' + GC.Author + ', ' + GC.CacheType + ' (' + GC.Difficulty + '/' + GC.Terrain + ')';
    {wWptUrl} wWptUrl := GC.URL;
    {wWptUrlName} wWptUrlName := GC.Name;
    {wSym} if GC.IsFound then wWptSym := 'Geocache Found' else wWptSym := 'Geocache';
    {wWptType} wWptType := 'Geocache|' + GC.CacheType;
    {wGsCacheID} wGsCacheID := GC.CacheID;
    {wGsAvailable} wGsAvailable := not GC.IsDisabled;
    {wGsArchived} wGsArchived := GC.IsArchived;
    {wGsName}
    if (not TemplateToOutput(TemplatePointName, GC, nil, wGsName)) 
      then ThrowTemplateRunningError(GetTemplatePointName + ' ' + GC.id);  
    {wGsPlacedBy} wGsPlacedBy := GC.Author;
    {wGsOwnerID} wGsOwnerID := GC.OwnerID;
    {wGsOwner} wGsOwner := GC.Author;
    {wGsType} if (GC.haveFinal and (FINAL_CATEGORY <> '')) then wGsType := AnsiToUtf(FINAL_CATEGORY) else wGsType := GC.CacheType;
    {wGsContainer} wGsContainer := GC.Size;
    {wGsDifficulty} wGsDifficulty := GC.Difficulty;
    {wGsTerrain} wGsTerrain := GC.Terrain;
    {wGsCountry} wGsCountry := GC.Country;
    {wGsState} wGsState := GC.State;
    {wGsShortDesc,wGsLongDesc}
    if (not TemplateToOutput(TemplatePointDescription, GC, nil, Listing)) 
      then ThrowTemplateRunningError(GetTemplatePointDescription + ' ' + GC.id);

      //Kontrola delky listingu
      if (CHECK_LISTING_LENGTH = '1') 
        then if (Length(Listing) > StrToInt(MAX_LISTING_CHARCOUNT)) then truncatedListings.Add(GC.ID);
        
      //Rozdeleni a zapis listingu
      wGsShortDesc := DivideListing(listing,wGsLongDesc,StrToInt(DIVIDE_LISTING_CHARCOUNT),GC.ID);
    
    {wGsHint} wGsHint := GC.Hint;
    {wGsLogs} wGsLogs := ExportLogs(GC);

    Result := Result + FormatPoint(wWptLat,wWptLon,wWptTime,wWptName,wWptCmt,wWptDesc,wWptUrl,wWptUrlName,wWptSym,wWptType,true,wGsCacheID,wGsAvailable,wGsArchived,wGsName,wGsPlacedBy,wGsOwnerID,wGsOwner,wGsType,wGsContainer,wGsDifficulty,wGsTerrain,wGsCountry,wGsState,wGsShortDesc,wGsLongDesc,wGsHint,wGsLogs);
  end;

  //EXPORT WAYPOINTU
  Result := Result + ExportWaypoints(GC);
end;
